<?php
/*
Plugin Name: my-comment
Plugin URI: http://wordpress.org/extend/plugins/my-comment/
Description: Comment author can view all his comments by clicking <a href='users.php?page=mycomment'>My Comment</a> link after enabling this plugin.
Author: Md. Jamal Hossain Khan
Version: 1.0
Author URI: http://www.krishe.com/

	Copyright 2010 Md. Jamal Hossain Khan (email : jamal_khanbd@yahoo.com)
 
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


define('COMMENT_PER_PAGE', 5);
add_action('admin_menu', 'add_menu_mycomment');

function add_menu_mycomment(){
	add_users_page('My Comment', 'My Comment', 'level_0', 'mycomment', 'get_my_comment');
	}
	
function get_my_comment(){
	
/**
	 * Adds an extra option on the comment row
	 *
	 * @WordPress Filter comment_row_actions
	 * @param array $actions
	 * @param class $comment
	 * @return array
	 * @since 1.0
	 */
	function filterCommentRowActions($actions,$comment){
	unset($actions['reply']);
	unset($actions['quickedit']);
	return $actions;
	}
	
add_filter('comment_row_actions','filterCommentRowActions',10,2);


	if ( current_user_can('edit_users') )
		$base_page = 'users.php?page=mycomment';
	else
		$base_page = 'profile.php?page=mycomment';

global $user_ID,$wpdb;

if( isset( $_GET['paged'] ) )   //If exists page in URl
    $paged = $_GET['paged'];    //Alter value to value in URL

$show_init = $paged * COMMENT_PER_PAGE;    //Start of show of records

if( $show_init <> 0 )
    $show_init = $paged * COMMENT_PER_PAGE - COMMENT_PER_PAGE;    //Start of show of records

if( !empty( $_GET['search'] ) and isset( $_GET['search'] ) ) :

    $search = $wpdb->escape( $_GET['search'] );

    $objComment = $wpdb->get_results( sprintf( "
        SELECT * FROM $wpdb->comments
        WHERE
        (comment_author LIKE '%%%s%%' OR
				comment_author_email LIKE '%%%s%%' OR
				comment_author_url LIKE ('%%%s%%') OR
				comment_author_IP LIKE ('%%%s%%') OR
				comment_content LIKE ('%%%s%%') ) AND user_id=$user_ID
        ORDER BY comment_date_gmt DESC
        LIMIT %d, %d
        ",$search,$search,$search,$search,$search,          
        $show_init,
        COMMENT_PER_PAGE
    ) );

    $objCommentCount = $wpdb->get_var("
        SELECT COUNT(*) FROM $wpdb->comments 
        WHERE
        (comment_author LIKE '%$search%' OR
				comment_author_email LIKE '%$search%' OR
				comment_author_url LIKE ('%$search%') OR
				comment_author_IP LIKE ('%$search%') OR
				comment_content LIKE ('%$search%') ) AND user_id=$user_ID"
    );


else :

    $objComment = $wpdb->get_results( $wpdb->prepare( "
        SELECT * FROM $wpdb->comments WHERE user_id=$user_ID
        ORDER BY comment_date_gmt DESC
        LIMIT %d, %d
        ",
        $show_init,
        COMMENT_PER_PAGE
    ) );

    $objCommentCount = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->comments WHERE user_id=$user_ID" );

endif;

$page_links = paginate_links( array(
    'base' => add_query_arg( 'paged', '%#%' ),
    'format' => '',
    'prev_text' => __('&laquo;'),
    'next_text' => __('&raquo;'),
    'total' => ceil($objCommentCount/COMMENT_PER_PAGE), // Max num pages
    'current' => (isset( $_GET['paged'] ) ) ? $_GET['paged'] : 1
));
?>
<?php if ( $page_links ) {  
            $paged = $_GET['paged'];
            if( $paged == 0 )
                $paged = 1;

            $page_links_text = sprintf( '<span class="displaying-num">' . __( 'Displaying %s&#8211;%s of %s' ) . '</span>%s',
            number_format_i18n( ( $paged - 1 ) * COMMENT_PER_PAGE + 1 ),
            number_format_i18n( min( $paged * COMMENT_PER_PAGE, $objCommentCount ) ),
            number_format_i18n( $objCommentCount ),
            $page_links
            );
             } 
             ?>
<div class="wrap">
             <form action="<?php echo htmlspecialchars($_SERVER['REQUEST_URI']); ?>" method="get">
                    <h2><?php _e('My Comment'); echo(" (". number_format_i18n($objCommentCount).")"); ?><img style="margin-right: 5px;" src="<?php echo plugins_url(dirname(plugin_basename(__FILE__)).'/comments.jpeg' )?>" alt="My Comment"/></h2>
                    <div class="tablenav">
                        <p class="search-box">
                            <input type="text" class="search-input" id="search" name="search" value="<?php echo $_GET['search']; ?>" />
                            <input type="hidden" name="page" value="<?php echo $_GET['page']; ?>" />
                            <input type="submit" class="button-secondary action" id="act_search" name="act_search" value="<?php _e('Search'); ?>" />
                        </p>

                    <br class="clear"/>
                     <!-- Pagination -->

										        <div class="tablenav">
										
										            <?php
										            if ( $page_links )
										                echo "<div class='tablenav-pages'>$page_links_text</div>";
										            ?>
										
										        </div>
										
										        <!-- / Pagination -->
                    </div>
                    <br class="clear"/>
                    <table class="widefat fixed">
                        <thead>
                            <tr>
                                <th scope="col"><?php _e('Author'); ?></th>
                                <th scope="col"><?php _e('Comment'); ?></th>
                                <th scope="col"><?php _e('In Response To'); ?></th>
                            </tr>
                        </thead>
                        <tbody>
                        <?php

                        if( $objComment ) :
                            foreach( $objComment as $comment ) : 

													_wp_comment_row( $comment->comment_ID,'list', 'all',false);

                          endforeach; ?>



                        <?php elseif( isset( $_GET['search']) and !empty( $_GET['search'] ) ) : ?>
                            <tr>
                                <td colspan="3"><strong><?php printf( '%s "%s". <a href="%s">%s</a>.', __('No Comment with the term: '), $_GET['search'], $base_page, __( 'Show all Comment' ) ); ?></strong></td>
                            </tr>
                        <?php else : ?>
                            <tr>
                                <td colspan="3"><strong><?php _e('No Comment until the moment.'); ?></strong></td>
                            </tr>
                        <?php endif; ?>
                        </tbody>
                    </table>
                </form>



        <!-- Pagination -->

        <div class="tablenav">

            <?php
            if ( $page_links )
                echo "<div class='tablenav-pages'>$page_links_text</div>";
            ?>

        </div>
</div>
        <!-- / Pagination -->

<?php


}

?>